#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <fun>

#define ARMOR_LEVEL ADMIN_LEVEL_A
#define GRENADE_LEVEL ADMIN_LEVEL_B
#define AMMO_LEVEL ADMIN_LEVEL_C
#define MONEY_LEVEL ADMIN_LEVEL_D
#define VAMPIR_LEVEL ADMIN_LEVEL_E
#define KNIFE_LEVEL ADMIN_LEVEL_F
#define SNIPER_LEVEL ADMIN_LEVEL_G

#define VIP_MONEY 1000
#define VAMPIR_HP 15
#define KNIFE_HP 300
#define KNIFE_SPEED 1000.0

new knife_only[33]
new knife_mode[33]

public plugin_init()
{
        register_plugin("VIP Plugin", "0.0.0.1", "Brute")
        register_event("ResetHUD", "reset", "b")
	register_event("DeathMsg", "death_event", "a")
	register_event("CurWeapon", "check_knife", "be", "1=1")
	register_cvar("vp", "1")
	register_cvar("vp_armor", "1")
	register_cvar("vp_grenades", "1")
	register_cvar("vp_ammo", "1")
	register_cvar("vp_money", "1")
	register_cvar("vp_vampir", "1")
	register_cvar("vp_sniper", "1")
	register_cvar("vp_knife", "1")
	register_clcmd("say /k_on","k_on")
	register_clcmd("say /k_off","k_off")
	server_cmd("sv_maxspeed 2000")
	set_task(0.1,"knife_speed_fix",0,"",0,"b")
}


public reset(id, level, cid)
{
	if(get_cvar_num("vp") != 0)
	{
		new CsTeams:userTeam = cs_get_user_team(id)
		if(userTeam == CS_TEAM_T || userTeam == CS_TEAM_CT)
		{
			if(get_user_flags(id) & ARMOR_LEVEL)
			{
				set_task(3.0, "vpar", id)
			}
			if(get_user_flags(id) & GRENADE_LEVEL)
			{
				set_task(3.0, "vpg", id)
			}
			if(get_user_flags(id) & AMMO_LEVEL)
			{
				set_task(3.0, "vpa", id)
			}
			if(get_user_flags(id) & MONEY_LEVEL)
			{
				set_task(3.0, "vpm", id)
			}
			if(get_user_flags(id) & KNIFE_LEVEL)
			{
				knife_only[id] = 0
				set_user_maxspeed(id, 240.0)
			}
		}
	}
}


public vpar(id)
{
	if(get_cvar_num("vp") != 0 && get_cvar_num("vp_armor") != 0)
	{
		give_item(id,"item_assaultsuit")
		client_print(id, print_chat, "[VIP PLUGIN]:You GIVE ARMOR+HELMET")
	}
}

public vpg(id)
{
	if(get_cvar_num("vp") != 0 && get_cvar_num("vp_grenades") != 0)
	{
		give_item(id,"weapon_flashbang")
		give_item(id,"weapon_flashbang")
		give_item(id,"weapon_hegrenade")
		give_item(id,"weapon_smokegrenade")
		client_print(id, print_chat, "[VIP PLUGIN]:You GIVE GRENADES")
	}
}

public vpa(id)
{
	if(get_cvar_num("vp") != 0 && get_cvar_num("vp_ammo") != 0)
	{
		cs_set_user_bpammo(id, CSW_USP, 100) 
       		cs_set_user_bpammo(id, CSW_ELITE, 120) 
        	cs_set_user_bpammo(id, CSW_DEAGLE, 35) 
        	cs_set_user_bpammo(id, CSW_GLOCK18, 120) 
        	cs_set_user_bpammo(id, CSW_P228, 52) 
        	cs_set_user_bpammo(id, CSW_FIVESEVEN, 100) 
        	cs_set_user_bpammo(id, CSW_XM1014, 32) 
        	cs_set_user_bpammo(id, CSW_M3, 32) 
        	cs_set_user_bpammo(id, CSW_P90, 100) 
        	cs_set_user_bpammo(id, CSW_MAC10, 100) 
        	cs_set_user_bpammo(id, CSW_MP5NAVY, 120) 
        	cs_set_user_bpammo(id, CSW_TMP, 120) 
        	cs_set_user_bpammo(id, CSW_UMP45, 100) 
        	cs_set_user_bpammo(id, CSW_FAMAS, 90) 
        	cs_set_user_bpammo(id, CSW_GALIL, 90) 
        	cs_set_user_bpammo(id, CSW_SCOUT, 90) 
        	cs_set_user_bpammo(id, CSW_AUG, 90) 
        	cs_set_user_bpammo(id, CSW_M4A1, 90) 
        	cs_set_user_bpammo(id, CSW_AK47, 90) 
        	cs_set_user_bpammo(id, CSW_SG552, 90) 
        	cs_set_user_bpammo(id, CSW_G3SG1, 90) 
        	cs_set_user_bpammo(id, CSW_SG552, 90) 
        	cs_set_user_bpammo(id, CSW_AWP, 30) 
        	cs_set_user_bpammo(id, CSW_M249, 200) 
		client_print(id, print_chat, "[VIP PLUGIN]:You GIVE AMMO")
	}
}

public vpm(id)
{
	if(get_cvar_num("vp") != 0 && get_cvar_num("vp_money") != 0)
	{	
		cs_set_user_money(id, cs_get_user_money(id) + VIP_MONEY)
		client_print(id, print_chat, "[VIP PLUGIN]:You GIVE %d MONEY", VIP_MONEY)
	}
}

public death_event(id, level, cid)
{
	new killer = read_data(1)
	if(get_cvar_num("vp") != 0 && get_cvar_num("vp_vampir") != 0)
	{
		if(get_user_flags(killer) & VAMPIR_LEVEL)
		{
			set_user_health(killer, get_user_health(killer)+VAMPIR_HP)
			client_print(killer, print_chat, "[VIP PLUGIN]:You GIVE %d HP", VAMPIR_HP)
		}
	}
}

public k_on(id)
{
	knife_mode[id] = 1
	strip_user_weapons(id)
	give_item(id,"weapon_knife")
}

public k_off(id)
{
	knife_mode[id] = 0
	client_print(id, print_chat, "[VIP PLUGIN]:KNIFE ONLY DISABLE")
}

public check_knife(id, level, cid)
{
	if(get_cvar_num("vp") != 0 && !is_user_bot(id))
	{
		if(get_user_flags(id) & KNIFE_LEVEL)
		{
			if(knife_mode[id] == 1 && knife_only[id] == 0 && get_cvar_num("vp_knife") != 0)
			{
				knife_only[id] = 1
				set_user_health(id, get_user_health(id)+KNIFE_HP)
				client_print(id, print_chat, "[VIP PLUGIN]:You GIVE %d HP", KNIFE_HP)
				client_print(id, print_chat, "[VIP PLUGIN]:KNIFE ONLY ENABLE")
			}
			if(get_user_weapon(id) != 29 && knife_only[id] == 1)
			{
				strip_user_weapons(id)
				give_item(id,"weapon_knife")
			}
		}
		if(get_user_flags(id) & SNIPER_LEVEL && get_cvar_num("vp_sniper") != 0)
		{

		}
		else if(get_user_weapon(id) == 13 || get_user_weapon(id) == 3 || get_user_weapon(id) == 18 || get_user_weapon(id) == 24)
		{
			engclient_cmd(id,"drop", "weapon_scout")
			engclient_cmd(id,"drop", "weapon_awp")
			engclient_cmd(id,"drop", "weapon_g3sg1")
			engclient_cmd(id,"drop", "weapon_sg550")
			client_print(id, print_chat, "[VIP PLUGIN]:SNIPERS WEAPONS FOR VIP'S ONLY!"
		}
	}
}

public knife_speed_fix(id)
{
	if(get_cvar_num("vp") != 0 && get_cvar_num("vp_knife") != 0)
	{
		if(get_user_flags(id) & KNIFE_LEVEL)
		{
			if(knife_only[id] == 1)
				set_user_maxspeed(id, 240.0 + KNIFE_SPEED)
		}
	}
}